unit kompon;
  { obsahuje komponentu TDisplay, kterou pouziju pri zobrazovani }

interface
uses Windows,Classes,Graphics,Controls;

type
  TDisplay = class(TGraphicControl)
  private
    FText,FFun     : String;
    procedure SetText(Value : String);
    procedure SetFun(Value : String);
  public

    property Text : string read FText write SetText; { napis }
    property Fun : string read FFun write SetFun; { funkce }
    procedure Paint; override;
    constructor Create(AOwner: TComponent); override;
  end;

implementation

constructor TDisplay.Create(AOwner: TComponent);
begin

  inherited;
  FText := '0';
  width := 100;
  height := 32;

end;

procedure TDisplay.SetText(Value : String);
begin

  if ftext = value then exit;
  FText := Value;
  Paint;

end;

procedure TDisplay.SetFun(Value : String);
begin

  if ffun = value then exit;
  FFun := Value;
  Paint;

end;

procedure TDisplay.Paint;
var
  s : string;

begin

  with canvas do
   begin
    brush.color := rgb(160,160,160);
    pen.color := brush.color;
    fillrect(bounds(0,0,width,height));
    font.color := 0;
    font.Name := 'MS Serif';
    font.size := 12;
    font.style := [fsbold];
    if ftext = '' then s := '0' else s := ftext;
    TextOut(width-5-TextWidth(FText),height-3-TextHeight(FText),s);
    font.name := 'Arial';
    font.size := 16;
    font.style := [fsbold];
    TextOut(5,5,FFun);
   end;

end;

end.
