unit Main;
{ POZOR! az budete tukat cisla na klavesnici a nepude to,
  vypnete cestinu(asi se sama zapina po spusteni programu) }


interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Kompon, Spin;

type
   { cleny vyrazu }
  TClenType = (TPCislo,TPPlus,TPMinus,TPKrat,TPDiv,TPLZav,TPPZav,TPNic);
  TClen = record
    Typ    : TClenType;
    Value  : Int64;
  end;
  { format meho cisla je:
    cislo[1]  ... posledni cifra
      nula je ulozena jako znak #1 atd }
  TCislo = string;

  TMainForm = class(TForm)
    TopBox: TGroupBox;
    GroupBox2: TGroupBox;
    NumBut0: TButton;
    NumBut1: TButton;
    NumBut2: TButton;
    NumBut3: TButton;
    NumBut5: TButton;
    NumBut6: TButton;
    NumBut4: TButton;
    NumBut7: TButton;
    NumBut8: TButton;
    NumBut9: TButton;
    BackBut: TButton;
    CEButton: TButton;
    PlusMinusBut: TButton;
    RovnBut: TButton;
    PlusBut: TButton;
    MinusBut: TButton;
    KratBut: TButton;
    DivBut: TButton;
    CButton: TButton;
    Label1: TLabel;
    SoustEdit: TSpinEdit;
    MemEdit: TSpinEdit;
    ToMemBut: TButton;
    GetMemBut: TButton;
    AddMemBut: TButton;
    Label2: TLabel;
    procedure CisloClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure SoustEditChange(Sender: TObject);
    procedure BackButClick(Sender: TObject);
    procedure CEButtonClick(Sender: TObject);
    procedure PlusMinusButClick(Sender: TObject);
    procedure RovnButClick(Sender: TObject);
    procedure PlusButClick(Sender: TObject);
    procedure MinusButClick(Sender: TObject);
    procedure DivButClick(Sender: TObject);
    procedure KratButClick(Sender: TObject);
    procedure CButtonClick(Sender: TObject);
    procedure ToMemButClick(Sender: TObject);
    procedure GetMemButClick(Sender: TObject);
    procedure AddMemButClick(Sender: TObject);
    procedure GroupBox2Click(Sender: TObject);
  private
    { Private declarations }
    FText         : String;  { text, kterej je napsanej na obrazovce }
    procedure SetText(Value : String);
  public
    { Public declarations }
    Dis          : TDisplay;

    Soust        : Integer; { aktualni ciselna soustava }
    Vyraz        : Array[1..500] of TClen;
    PocVyr       : Integer; { pocet clenu nahore }
     { sem si ulozim vyraz ktery clovek
     zada a potom se to bude pocitat }
    Error        : Boolean;

    Memory       : Array[1..36] of Int64;

    property Text : String read FText write SetText;

    function MemNum : Integer; { vraci cislo pameti }
    procedure AddClen(typ : tclentype; value : int64);
    procedure ZpracujKlavesu(kl : char);
     { uzivatel neco zmackl a jde to do teto procedury }
    procedure ZmenSoustavu(NaCo : Integer);
     { zmeni ciselnou soustavu }
    procedure Spocti;
     { spocte vyraz v promenne VYRAZ }
  end;

var
  MainForm: TMainForm;

implementation
{$R *.DFM}

function Cifra(Cislo : TCislo; poz : Integer) : integer;
begin { vrati POZ cifru daneho cisla }

  if poz > length(cislo) then result := 0 else
   result := byte(cislo[poz])-1;

end;

function Soust2Bin(Soust : Integer; Cislo : TCislo) : Int64;
var
  pom   : int64;
  n     : integer;

begin

  pom := 0;
  for n := length(cislo) downto 1 do pom := pom*soust+Cifra(cislo,n);
  result := pom;

end;

function Bin2Soust(Soust : Integer; Cislo : Int64) : TCislo;
var
  pom   : int64;
  dest  : tcislo;

begin { prevod binarni -> libovolna }

  pom := cislo; dest := '';
  while pom <> 0 do
   begin
    dest := dest+char(pom mod soust+1);
    pom := pom div soust;
   end;
  result := dest;

end;

function Str2Cislo(csl : string) : TCislo;
var
  n : integer;

begin { prevede cislo zapsane normalne ve stringu na muj format }
  result := '';
  for n := length(csl) downto 1 do if byte(csl[n]) < 64 then
   result := result + char(byte(csl[n])-47) else
   result := result + char(byte(csl[n])-54);

end;

function Cislo2Str(csl : TCislo) : String;
var
  n : integer;

const
  tab   : array[0..36] of char = '0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ';

begin { opacny prevod nez nahore }
  result := '';
  for n := 1 to length(csl) do result := tab[byte(csl[n])-1]+result;
end;


      { TMainForm }
procedure TMainForm.AddClen(typ : tclentype; value : int64);
begin

  inc(pocvyr);
  vyraz[pocvyr].typ := typ;
  vyraz[pocvyr].value := value;

end;

procedure TMainForm.SetText(Value : String);
begin

  FText := Value;
  dis.Text := FText;

end;

procedure TMainForm.ZpracujKlavesu(kl : char);
var
  csl    : byte;

begin

  error := false;
  case upcase(kl) of
  '0'..'9','A'..'Z' : if length(text) < 30 then
   begin
    dis.Fun := '';
    while (length(ftext)>0) and (ftext[1]='0') do delete(ftext,1,1);
     { smazu nuly na zacatku }

    if byte(upcase(kl)) < 65 then csl := byte(kl)-48
     else csl := byte(upcase(kl))-55;
    if csl >= soust then exit;
    text := text+upcase(kl);
   end;
  '+','-','*','/'    :
   begin
    dis.fun := kl;
    if text<>'' then addclen(TPCislo,Soust2Bin(Soust,Str2Cislo(text)));
    case kl of
    '+'  : addclen(TPPlus,0);
    '-'  : addclen(TPMinus,0);
    '*'  : addclen(TPKrat,0);
    '/'  : addclen(TPDiv,0);
    end;
    ftext := ''; { pisu to schvalne rovnou do FText,
     protoze nechci, aby cislo zadane pred operaci hned
     zmizelo }
   end;
  '(',')'   :
   begin
    dis.fun := kl;
    if text<>'' then addclen(TPCislo,Soust2Bin(Soust,Str2Cislo(text)));
    if kl = '(' then addclen(TPLZav,0) else addclen(TPPZav,0);
    ftext := '';
   end;
  #8  : BackButClick(self); {backspace}
  '=' :
   begin
    dis.fun := '=';
    Spocti;
   end;
  end;
  rovnbut.SetFocus;

end;

procedure TMainForm.ZmenSoustavu(NaCo : Integer);
begin

  Text := Cislo2Str(Bin2Soust(NaCo,Soust2Bin(Soust,Str2Cislo(Text))));
  Soust := NaCo;

end;

procedure TMainForm.Spocti;
var
  n,nahrada  : integer; { nahrazoval jsem neco ? }
  akt        : int64; { pomocne promenne }

 procedure Nahrad(poz1,kolik : integer; CimTyp : TClenType; CimValue : Int64);
 begin { procedure nahradi v mem seznamu clenu KOLIK clenu od pozice
  POZ1 clenem CIMxxx }

   move(vyraz[poz1+kolik],vyraz[poz1+1],sizeof(tclen)*(pocvyr-poz1-kolik+1));
   dec(pocvyr,kolik-1);
   vyraz[poz1].typ := cimtyp;
   vyraz[poz1].value := cimvalue;
   nahrada := 1; { nahrazoval jsem }

 end;

 function ClenTP(poz : integer) : TClenType;
 begin

   if (poz < 1) or (poz > pocvyr) then result := TPNic
    else result := vyraz[poz].typ;

 end;

begin

  if text<>'' then addclen(TPCislo,Soust2Bin(Soust,Str2Cislo(text)));
   { pokud bylo jeste neco napsano, tak si to ulozim }

  { princip bude ten, ze budu porad projizdet vyraz a pocitat
   elementarni veci, az mi vyjde bud cislo nebo nesmysl }
  error := false;
  repeat
   nahrada := 0;
   n := 1;
   while (n <= pocvyr) and (not error) do
    begin
     if (clentp(n)=TPCislo) and (clentp(n+1)=TPKrat) and (clentp(n+2)=TPCislo) then
      nahrad(n,3,TPCislo,vyraz[n].value*vyraz[n+2].value);
       { nasobeni }
     if (clentp(n)=TPCislo) and (clentp(n+1)=TPDiv) and (clentp(n+2)=TPCislo) then
      if vyraz[n+2].value <> 0 then nahrad(n,3,TPCislo,trunc(vyraz[n].value/vyraz[n+2].value)) else
        error := true;
       { deleni }
     if (clentp(n)=TPCislo) and (clentp(n+1)=TPPlus) and (clentp(n+2)=TPCislo)
      and (not (clentp(n-1)in[TPKrat,TPDiv])) and (not (clentp(n+3)in[TPKrat,TPDiv])) then
       nahrad(n,3,TPCislo,vyraz[n].value+vyraz[n+2].value);
       { scitani }
     if (clentp(n)=TPCislo) and (clentp(n+1)=TPMinus) and (clentp(n+2)=TPCislo)
      and (not (clentp(n-1)in[TPKrat,TPDiv])) and (not (clentp(n+3)in[TPKrat,TPDiv])) then
       nahrad(n,3,TPCislo,vyraz[n].value-vyraz[n+2].value);
       { odcitani }

     if (clentp(n)=TPLZav) and (clentp(n+1)=TPCislo) and (clentp(n+2)=TPPZav) then
       nahrad(n,3,TPCislo,vyraz[n+1].value);
       { cislo v zavorce }
     inc(n);
    end;
  until (nahrada = 0) or (error);

  if (error=true)or(pocvyr<>1) or (vyraz[1].typ <> TPCislo) then
   begin
    dis.Fun := 'Err';
    text := '';
   end else
    begin
     text := Cislo2Str(Bin2Soust(soust,vyraz[1].value));
    end;
  pocvyr := 0;

end;

procedure TMainForm.CisloClick(Sender: TObject);
begin
{}
  { tbutton to musi byt vzdy ale pro jistotu to zkusim }
  if (sender is TButton) then ZpracujKlavesu((sender as TButton).name[7]);

end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
{}
  dis := TDisplay.Create(topbox);
  dis.width := topbox.ClientWidth-10;
  dis.left := 5;
  dis.top := 11; { vytvorim a pridam do Top boxu novou komponentu }
  topbox.InsertControl(dis);

  soust := 10;

end;

procedure TMainForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
{}
  if not soustedit.Focused then ZpracujKlavesu(Key);

end;

procedure TMainForm.SoustEditChange(Sender: TObject);
var
  n,m : integer; { pomocne promenne }

begin
{}
  val(soustedit.text,n,m);
  if (soustedit.text <> '') and (m = 0) and (n > 1) and (n < 37) then
   ZmenSoustavu(n); { vse je v pohode -> zmena }

end;

procedure TMainForm.BackButClick(Sender: TObject);
begin
{}
  if length(text) <> 0 then text := copy(text,1,length(text)-1);

end;

procedure TMainForm.CEButtonClick(Sender: TObject);
begin
{}
  text := '';

end;

procedure TMainForm.PlusMinusButClick(Sender: TObject);
begin
{}
  if (text='') or (text[1]<>'-') then text := '-'+text
   else text := copy(text,2,1000);

end;

procedure TMainForm.RovnButClick(Sender: TObject);
begin
  ZpracujKlavesu('=');
end;

procedure TMainForm.PlusButClick(Sender: TObject);
begin
  ZpracujKlavesu('+');
end;

procedure TMainForm.MinusButClick(Sender: TObject);
begin
  ZpracujKlavesu('-');
end;

procedure TMainForm.DivButClick(Sender: TObject);
begin
  ZpracujKlavesu('/');
end;

procedure TMainForm.KratButClick(Sender: TObject);
begin
  ZpracujKlavesu('*');
end;

procedure TMainForm.CButtonClick(Sender: TObject);
begin
{}
  text := '';
  pocvyr := 0;
  dis.Fun := '';

end;

function TMainForm.MemNum : Integer; { vraci cislo pameti }
var
  m : integer;

begin { hlavne dava pozor na blbuvzdornost }
  val(memedit.text,result,m);
  if (memedit.text = '') or (result < 1) or (result > 36) then result := 0;
end;

procedure TMainForm.ToMemButClick(Sender: TObject);
var  num : integer;
begin
{}
  num := memnum;
  if num = 0 then exit;
  spocti;
  if not error then
   begin
    memory[num] := vyraz[1].value;
    dis.Fun := 'X->M';
   end;

end;

procedure TMainForm.GetMemButClick(Sender: TObject);
var  num : integer;
begin
{}
  num := memnum;
  if num = 0 then exit;
  text := Cislo2Str(Bin2Soust(soust,memory[num]));
  dis.Fun := 'RM';

end;

procedure TMainForm.AddMemButClick(Sender: TObject);
var  num : integer;
begin
{}
  num := memnum;
  if num = 0 then exit;
  spocti;
  if not error then
   begin
    memory[num] := memory[num]+vyraz[1].value;
    dis.Fun := 'M+';
   end;

end;

procedure TMainForm.GroupBox2Click(Sender: TObject);
begin
{}
  rovnbut.SetFocus;

end;

end.
